#!/usr/bin/perl -w

# LSB Test Execution Framework
# Browse for RPM Package Module (choose_pkg.pl)
#
# Copyright (C) 2007 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;

my $packager = ($is_packager_rpm ? "RPM" : "DEB");

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>RPM Packages</title>
  <style type="text/css">
	table.main {
		border: 0px solid black;
		border-collapse: collapse;
	}
	table.main td, table.main th {
		border: 1px solid black;
		padding: 4px;
		white-space: nowrap;
	}
	table.main td {
		font-family: monospace;
		font-size: 10pt;
	}
	table.main td.selected {
		color: red;
	}
	tr.list_item0 {
		background: #e7e7e7;
	}
	tr.list_item1 {
		background: #ffffff;
	}
	tr.clickable:hover {
		background-color: #d0d0ff;
		cursor: pointer;
	}
	td h3 {
		margin-top: 10px;
		margin-bottom: 0px;
	}
  </style>
</head>

<body>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Preload images
var preload_image_names = new Array('open_folder.gif', 'select_active.gif', 'select_inactive.gif');
var preload_images = new Array();
for (var i=0; i<preload_image_names.length; ++i) {
	preload_images[i] = new Image;
	preload_images[i].src = 'images/' + preload_image_names[i];
}

function check_unckeck(id, update_chk) {
	var chkbox = document.getElementById('chk-' + id);
	var pkgname = document.getElementById('pkg-' + id);
	if (chkbox && pkgname) {
		if (update_chk) {
			if (chkbox.checked) {
				chkbox.checked = false;
				pkgname.className = '';
			}
			else {
				chkbox.checked = true;
				pkgname.className = 'selected';
			}
		}
		else {
			if (chkbox.checked) {
				pkgname.className = 'selected';
			}
			else {
				pkgname.className = '';
			}
		}
	}
}

function put_to_list() {
	if (opener) {
		var elem = opener.document.getElementById("packages");
		var arr = document.getElementsByTagName('td');
		var first_elem = '';
		if (elem && arr) {
			var to_add = '';
			for (var i=0; i<arr.length; ++i) {
				if (arr[i].className == 'selected') {
					var tmp;
					if (typeof(arr[i].innerText) == "undefined")
						tmp = arr[i].textContent;
					else
						tmp = arr[i].innerText;
					to_add += tmp + '\\n';
					if (first_elem == '')
						first_elem = tmp;
				}
			}
			elem.value = to_add;
		}
		var app_name = opener.document.getElementById('application');
		if (app_name && (app_name.value == '')) {
			app_name.value = first_elem;
		}
	}
	window.close();
}

// ]]>
</script>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td align="left" width="100%"><h3>Select Installed $packager Packages:</h3></td>
    <td><img src="images/environment-spacer.gif" width="10" height="1" border="0" alt="" /></td>
    <td align="right"><h3><a href="tests_help.pl#browse_pkg" target="_blank">Help</a></h3></td>
  </tr>
</table>
DATA

my @packages = split(/\n/, ($is_packager_rpm ?
	`rpm -qa --qf "\%\{NAME\}\\t\%\{VERSION\}\\t\%\{RELEASE\}\\n" | sort` :
	`dpkg-query -W -f '\${Package}\t\${Version}\t\${Status}\n' | sort`
));

my $odd_line = 0;
my $table_data = "";

if ($is_packager_rpm) {
	$table_data = <<DATA;
<table class="main">
  <tr>
    <th width="30"></th>
    <th style="width: 20em;">Name</th>
    <th>Version</th>
    <th>Release</th>
  </tr>
DATA
	foreach my $pkg (@packages) {
		my ($name, $ver, $rel) = split(/\t/, $pkg, 3);
		next if ($name eq "gpg-pubkey");
		my $checked = "";
		my $selected = "";
		if ($_GET{$name}) {
			$checked = " checked=\"checked\"";
			$selected = " class=\"selected\"";
			delete $_GET{$name};
		}
		my $name_id = "$name-$ver-$rel";
		$name_id =~ s/\+/p/g;
		$name_id =~ s/~/-/g;
		$table_data .= <<DATA;
  <tr class="list_item$odd_line clickable">
    <td align="center"><input type="checkbox" id="chk-$name_id"$checked onclick="javascript:check_unckeck('$name_id', false);" /></td>
    <td id="pkg-$name_id"$selected onclick="javascript:check_unckeck('$name_id', true);"><b>$name</b></td>
    <td onclick="javascript:check_unckeck('$name_id', true);">$ver</td>
    <td onclick="javascript:check_unckeck('$name_id', true);">$rel</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}
}
else {
	$table_data = <<DATA;
<table class="main">
  <tr>
    <th width="30"></th>
    <th style="width: 20em;">Name</th>
    <th>Version</th>
  </tr>
DATA
	foreach my $pkg (@packages) {
		my ($name, $ver, $st) = split(/\t/, $pkg, 3);
		next if ($st ne "install ok installed");
		my $checked = "";
		my $selected = "";
		if ($_GET{$name}) {
			$checked = " checked=\"checked\"";
			$selected = " class=\"selected\"";
			delete $_GET{$name};
		}
		my $name_id = "$name-$ver";
		$name_id =~ s/\+/p/g;
		$name_id =~ s/~/-/g;
		$table_data .= <<DATA;
  <tr class="list_item$odd_line clickable">
    <td align="center"><input type="checkbox" id="chk-$name_id"$checked onclick="javascript:check_unckeck('$name_id', false);" /></td>
    <td id="pkg-$name_id"$selected onclick="javascript:check_unckeck('$name_id', true);"><b>$name</b></td>
    <td onclick="javascript:check_unckeck('$name_id', true);">$ver</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}
}

$table_data .= "</table>\n";

my $absent_packages = "<br />\n";
if (scalar(keys %_GET) > 0) {
	$absent_packages = join("</li>\n  <li>", keys %_GET);
	$absent_packages = <<DATA;
<br />
<div style="color: red;"><b>The following packages are selected but not installed:</b>
<ul>
  <li>$absent_packages</li>
</ul>
</div>
DATA
}

print <<DATA;
$absent_packages
<input type="button" value="Finish" style="border: 1px solid black; background: white; width: 100px; font-weight: bold;" onclick="javascript:put_to_list();" /><br /><br />
$table_data
<br /><input type="button" value="Finish" style="border: 1px solid black; background: white; width: 100px; font-weight: bold;" onclick="javascript:put_to_list();" />

</body>
</html>
DATA
